package xyz.etztech.deluxegroups.events;

import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;

public class GlobalChatEvent extends Event implements Cancellable {
    private Player author;
    private String message;

    public GlobalChatEvent(Player author, String message) {
        this.author = author;
        this.message = message;
    }

    public Player getAuthor() {
        return author;
    }

    public String getMessage() {
        return message;
    }

    //
    //  - - - HandlerList boilerplate - - -
    //

    public static final HandlerList HANDLERS = new HandlerList();

    @Override
    public HandlerList getHandlers() { return HANDLERS; }

    public static HandlerList getHandlerList() { return HANDLERS; }

    //
    //  - - - Cancellable boilerplate - - -
    //

    private boolean isCancelled = false;

    @Override
    public boolean isCancelled() { return isCancelled; }

    @Override
    public void setCancelled(boolean cancelled) { isCancelled = cancelled; }
}
