package xyz.etztech.deluxegroups.listeners;

import github.scarsz.discordsrv.DiscordSRV;
import github.scarsz.discordsrv.dependencies.jda.api.entities.TextChannel;
import org.bukkit.ChatColor;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import xyz.etztech.deluxegroups.DeluxeGroups;
import xyz.etztech.deluxegroups.events.GlobalChatEvent;
import xyz.etztech.deluxegroups.events.GroupChatEvent;

public class DGListener implements Listener {

    private DeluxeGroups plugin;

    public DGListener(DeluxeGroups deluxeGroups) {
        this.plugin = deluxeGroups;
    }

    @EventHandler
    public void onGlobalChat(GlobalChatEvent event) {
        TextChannel mainChannel = DiscordSRV.getPlugin().getMainTextChannel();
        if (mainChannel != null) {
            String message = DiscordSRV.config().getString("MinecraftChatToDiscordMessageFormatNoPrimaryGroup").
                    replace("%displayname%", event.getAuthor().getName()).
                    replace("%message%", event.getMessage());
            mainChannel.sendMessage(message).queue();
        }
    }

    @EventHandler
    public void onGroupChat(GroupChatEvent event) {
        TextChannel groupChannel = DiscordSRV.getPlugin().getDestinationTextChannelForGameChannelName(event.getGroup().getName());
        if (groupChannel != null) {
            String discordFormat = plugin.getConfig().getString("discord.mtd", "<author> > <message>");
            String message = discordFormat.
                    replace("<group>", event.getGroup().getName()).
                    replace("<message>", ChatColor.stripColor(event.getMessage())).
                    replace("<author>", event.getAuthor().getName());
            groupChannel.sendMessage(message).queue();
        }
    }
}
